linuxptp: new package

Add the Linux PTP Project package.
http://linuxptp.sourceforge.net/

The SysV and systemd init scripts start the daemon in slave-only mode on eth0
and synchronize the system clock to PTP.

Signed-off-by: Petr Kulhavy <brain@jikos.cz>
Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com>
2017.08.x
Petr Kulhavy 2017-06-07 20:44:29 +02:00 committed by Thomas Petazzoni
parent 8a3accb72c
commit 09f1b8011b
9 changed files with 149 additions and 0 deletions

View File

@ -1292,6 +1292,9 @@ F: package/sdl2_gfx/
F: package/sdl2_image/
F: package/sdl2_ttf/
N: Petr Kulhavy <brain@jikos.cz>
F: package/linuxptp/
N: Petr Vorel <petr.vorel@gmail.com>
F: package/linux-backports/
F: package/ltp-testsuite/

View File

@ -1609,6 +1609,7 @@ menu "Networking applications"
source "package/links/Config.in"
source "package/linphone/Config.in"
source "package/linux-zigbee/Config.in"
source "package/linuxptp/Config.in"
source "package/lldpd/Config.in"
source "package/lrzsz/Config.in"
source "package/macchanger/Config.in"

View File

@ -0,0 +1,13 @@
config BR2_PACKAGE_LINUXPTP
bool "linuxptp"
help
The Linux PTP Project is the Precision Time Protocol
implementation according to IEEE standard 1588 for Linux.
The dual design goals are to provide a robust implementation
of the standard and to use the most relevant and modern
Application Programming Interfaces (API) offered by the
Linux kernel. Supporting legacy APIs and other platforms is
not a goal.
http://linuxptp.sourceforge.net/

View File

@ -0,0 +1,46 @@
#!/bin/sh
#
# Start linuxptp
#
start() {
printf "Starting linuxptp daemon: "
start-stop-daemon -S -b -q -p /var/run/linuxptp-ptp4l.pid \
-x /usr/sbin/ptp4l -- -f /etc/linuxptp.cfg
[ $? = 0 ] && echo "OK" || echo "FAIL"
printf "Starting linuxptp system clock synchronization: "
start-stop-daemon -S -b -q -p /var/run/linuxptp-phc2sys.pid \
-x /usr/sbin/phc2sys -- -s eth0 -c CLOCK_REALTIME -w -S 1.0
[ $? = 0 ] && echo "OK" || echo "FAIL"
}
stop() {
printf "Stopping linuxptp system clock synchronization: "
start-stop-daemon -K -q -p /var/run/linuxptp-phc2sys.pid \
-x /usr/sbin/phc2sys
echo "OK"
printf "Stopping linuxptp daemon: "
start-stop-daemon -K -q -p /var/run/linuxptp-ptp4l.pid \
-x /usr/sbin/ptp4l
echo "OK"
}
case "$1" in
start)
start
;;
stop)
stop
;;
restart|reload)
stop
start
;;
*)
echo "Usage: $0 {start|stop|restart}"
exit 1
esac
exit $?

View File

@ -0,0 +1,11 @@
[Unit]
Description=Precision Time Protocol system clock synchronization
After=syslog.target network.target
[Service]
ExecStart=/usr/sbin/phc2sys -s /dev/ptp0 -c CLOCK_REALTIME -w -S 1.0
Restart=always
[Install]
WantedBy=multi-user.target
WantedBy=linuxptp.service

View File

@ -0,0 +1,19 @@
# LinuxPTP configuration file for synchronizing the system clock to
# a remote PTP master in slave-only mode.
#
# By default synchronize time in slave-only mode using UDP and hardware time
# stamps on eth0. If the difference to master is >1.0 second correct by
# stepping the clock instead of adjusting the frequency.
#
# If you change the configuration don't forget to update the phc2sys
# parameters accordingly in linuxptp-system-clock.service (systemd)
# or the linuxptp SysV init script.
[global]
slaveOnly 1
delay_mechanism Auto
network_transport UDPv4
time_stamping hardware
step_threshold 1.0
[eth0]

View File

@ -0,0 +1,2 @@
# Locally computed:
sha256 b8190ab71a99f1dc32847f33cb301d2464d3f9e5f4c51300d55589aff42e8b3f linuxptp-97c351cafd7327fd28047580c9e2528a6f7e742b.tar.gz

View File

@ -0,0 +1,43 @@
################################################################################
#
# linuxptp
#
################################################################################
LINUXPTP_VERSION = 97c351cafd7327fd28047580c9e2528a6f7e742b
LINUXPTP_SITE_METHOD = git
LINUXPTP_SITE = git://git.code.sf.net/p/linuxptp/code
LINUXPTP_LICENSE = GPL-2.0+
LINUXPTP_LICENSE_FILES = COPYING
define LINUXPTP_BUILD_CMDS
$(TARGET_MAKE_ENV) $(MAKE) KBUILD_OUTPUT=$(TARGET_DIR) \
EXTRA_CFLAGS="$(TARGET_CFLAGS)" EXTRA_LDFLAGS="$(TARGET_LDFLAGS)" \
CC="$(TARGET_CC)" \
-C $(@D) all
endef
define LINUXPTP_INSTALL_TARGET_CMDS
$(TARGET_MAKE_ENV) $(MAKE) prefix=/usr DESTDIR=$(TARGET_DIR) \
$(TARGET_CONFIGURE_OPTS) -C $(@D) install
$(INSTALL) -D -m 644 $(LINUXPTP_PKGDIR)/linuxptp.cfg \
$(TARGET_DIR)/etc/linuxptp.cfg
endef
define LINUXPTP_INSTALL_INIT_SYSV
$(INSTALL) -m 755 -D $(LINUXPTP_PKGDIR)/S65linuxptp \
$(TARGET_DIR)/etc/init.d/S65linuxptp
endef
define LINUXPTP_INSTALL_INIT_SYSTEMD
$(INSTALL) -D -m 644 $(LINUXPTP_PKGDIR)/linuxptp.service \
$(TARGET_DIR)/usr/lib/systemd/system/linuxptp.service
$(INSTALL) -D -m 644 $(LINUXPTP_PKGDIR)/linuxptp-system-clock.service \
$(TARGET_DIR)/usr/lib/systemd/system/linuxptp-system-clock.service
mkdir -p $(TARGET_DIR)/etc/systemd/system/multi-user.target.wants
ln -sf ../../../../usr/lib/systemd/system/linuxptp.service \
$(TARGET_DIR)/etc/systemd/system/multi-user.target.wants/linuxptp.service
endef
$(eval $(generic-package))

View File

@ -0,0 +1,11 @@
[Unit]
Description=Precision Time Protocol daemon
After=syslog.target network.target
Wants=linuxptp-system-clock.service
[Service]
ExecStart=/usr/sbin/ptp4l -f /etc/linuxptp.cfg
Restart=always
[Install]
WantedBy=multi-user.target